<?php
/****************************************************************************
-----------------------------------------------------------------------------
 *  File            :     Service.php
 *  Subpackage      :     WSPlugin
 *  Packahe         :     Ebizon
 *  Description     :     It provides web services which is requested from IndexController.php
 *  File URL        :     http://192.168.1.101/magento/app/code/local/Ebizon/WSPlugin/controllers 
 *  Developer       :     Shashi Badhuk
 *  Team Lead       :     Shashank Singh
 *  Project Manager :     Utkarsh Srivastava
 *  CEO             :     Sudeep Goyal
 *  Organization    :     Ebizon Net Info Pvt Ltd 
 *  Org URL         :     http://www.ebizontek.com
-----------------------------------------------------------------------------
 *****************************************************************************/

class Service {
    /*====================      Service to fetch all category    =================*/
    public function ws_category($store, $service) {
           $res=array();try {
           $storecategoryid = Mage::app()->getStore($store)->getRootCategoryId();
           $total = 0;
           
                   
                $category = Mage::getModel('catalog/category'); 
                $tree = $category->getTreeModel(); 
                $tree->load();

                $ids = $tree->getCollection()->getAllIds(); 
                $arr = array();

                $storecategoryid = Mage::app()->getStore($store)->getRootCategoryId();
                $cat = Mage::getModel('catalog/category'); 
		        $cat->load($storecategoryid); 
		        $categories = $cat->getCollection()
				  ->addAttributeToSelect(array('name', 'image', 'description','store'))
				  ->addIdFilter($cat->getChildren());
                foreach($categories as $tmp){
					
                     $res[] = array(
                               "id" => $tmp->getId(),
                               "name" => $tmp->getName()
                               );
                     $total=$total+1;
		}                        
		
		array_push($arr, $cat); 
              //  $res = $res + '<br><br><br><center><b>Total Category : '.$total.'</b></center><br>';
           }
           catch(Exception $ex) {
                //$res = $res + 'Exception Problem : '.$ex;
           } 
           return($res);
    }
    public function ws_subcategory($store_id, $service, $categoryid) {
          Mage::app()->setCurrentStore($store_id);
          $res=array();
          $children = Mage::getModel('catalog/category')->getCategories($categoryid);
          foreach ($children as $category) {
			  $res[] = array(
                               "id" => $category->getId(),
                               "name" => $category->getName()
                               );
          }
          return($res);
    }
    public function ws_products($store_id, $service, $categoryid) {
          $res=array();
          Mage::app()->setCurrentStore($store_id); 
	  $c_id = $categoryid;
	  $category = new Mage_Catalog_Model_Category();
	  $category->load($c_id);
	  $collection = $category->getProductCollection()->addStoreFilter($store_id);
	  $collection->addAttributeToSelect('*');
                 
          foreach ($collection as $_product) {
		      //var_dump($_product); die;
                      $res[] = array(
                               "id" => $_product->getId(),
                               "name" => $_product->getName(),
                               "imageurl" => Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$_product->getImage(),
                               "sku" => $_product->getSku(),
                               "spclprice" => number_format($_product->getSpecialprice(),2),
                               "price" => number_format($_product->getPrice(),2),
                               "created_date" => $_product->getCreatedAt(),
                               "is_in_stock" => $_product->getStockItem()->getIsInStock(),
                               "stock_quantity" => Mage::getModel('cataloginventory/stock_item')->loadByProduct($_product->getId())->getQty()
                               ); 
	   } 
	   return($res); 
    }
        
    public function ws_getCustomerId($store, $service, $email) {
         $customer = Mage::getModel('customer/customer');
         $websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId();
         if ($store) {
               $customer->setCurrentStore($store);
               $customer->website_id = $websiteId;
         }
         $customer->loadByEmail($email);
         if ($customer->getId()) {
              $res = array();
              $res["id"] = $customer->getId();
              return $res;
         }
              return -1;
    }
    public function ws_verifyLogin($store, $service, $username, $password) {
        $websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId();
        $res = array();
        $res["username"] = $username;
        $res["password"] = $password;
        $login_status = 1; 
        try{
	     $login_customer_result = Mage::getModel('customer/customer')->setWebsiteId($websiteId)->authenticate($username, $password);
             $login_customer = Mage::getModel('customer/customer')->setWebsiteId($websiteId);
             $login_customer->loadByEmail($username);             
             $res["firstname"] = $login_customer->firstname;
             $res["lastname"] = $login_customer->lastname;
             $res["id"] = $login_customer->getId(); 
             //$res["password"]
             //$res["password"]
        }
        catch( Exception $e ){
             $login_status = 0;
        }
        $res["login_status"] = $login_status;
        return $res;
    }
    public function ws_createuser($store, $service, $firstname, $lastname, $email, $password) {
        // Website and Store details
        $res = array();
		$websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId(); 
		$customer = Mage::getModel("customer/customer");
		$customer->website_id = $websiteId;
		$customer->setCurrentStore($store);
              //  echo 'Phase 2';
		try {
		    // If new, save customer information
		    $customer->firstname = $firstname;
		    $customer->lastname = $lastname;
		    $customer->email = $email;
		    $customer->password_hash = md5($password);
		    $res["email"] =$email;
		    $res["firstname"] =$firstname;
		    $res["lastname"] =$lastname;
		    $res["password"] =$password;
		    $res["status"] = 0;
               	    $res["id"] = 0;
	   	    $cust = Mage::getModel('customer/customer')
				->setWebsiteId(Mage::app()->getStore()->getWebsiteId())
				->loadByEmail($email);
             
                    //check exists email address of users  
                    if ($cust->getId()) {
			$res["id"] = $cust->getId();
         	        $res["status"] = 0;                     
		    }else {
	 	    //echo 'Phase 2.5';
		     if($customer->save()){
               		 $customer->sendNewAccountEmail('confirmed');
               		 $this->send_Password_Mail_to_NewUser($firstname, $password, $email);
               		 $res["id"] = $customer->getId();
		         $res["status"] = 1;                               
		     }
		    else{
                       //echo "Already Exist";
		        $exist_customer = Mage::getModel("customer/customer");
                        $exist_customer->setWebsiteId($websiteId);                        
                        $exist_customer->setCurrentStore($store);
                        $exist_customer->loadByEmail($email);                       
                        $res["id"] = $exist_customer->getId();
                        $res["status"] = 1;                

	   		 //echo "An error occured while saving customer";
		     } 
		    }
            		//echo 'Phase 3';
		}
		
		catch(Exception $e){
		
                    //echo "Already Exist Exception";
                      try {
                        $exist_customer = Mage::getModel("customer/customer");
                        $exist_customer->setWebsiteId($websiteId);

                        $exist_customer->setCurrentStore($store);
                        $exist_customer->loadByEmail($email);

                        $res["id"] = $exist_customer->getId();
                        $res["status"] = 1;
                       }
                      catch(Exception $ex) {
                        $res["id"] = -1;
                        $res["status"] = 0;
                     }	
		}
		return $res;
     }
     public function ws_productdetail($store_id, $service, $productid) {
		 
          $res=array();
          
		 $productsCollection = Mage::getModel('catalog/product')
                                     ->getCollection()
                                     ->addAttributeToFilter('entity_id', array('in' => $productid))
                                     ->addAttributeToSelect('*');


           $all_product_images = array();
            $product = Mage::getModel('catalog/product')->load($productid);
                foreach ($product->getMediaGalleryImages() as $image) {
                    $all_product_images[] = $image->getUrl();
                 }

foreach($productsCollection as $product) {
                  $res["id"] = $product->getId();
		  $res["sku"] = $product->getSku();
		  $res["name"] = $product->getName();
		  $res["category"] = $product->getCategoryIds(); //'category';
		  $res["image"] = $all_product_images; // Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$product->getImage();
		  $res["url"] = $product->getProductUrl();
		  $res["description"] = $product->getDescription();
		  $res["shortdes"] = $product->getShortDescription();		  
		  $res["quantity"] = Mage::getModel('cataloginventory/stock_item')->loadByProduct($productid)->getQty();//$product->getQty(); 
		  $res["visibility"] = $product->isVisibleInSiteVisibility();//getVisibility(); 
		  $res["type"] = $product->getTypeID();
		  $res["weight"] = $product->getWeight();
		  $res["status"] = $product->getStatus(); 
		  $res["price"] = number_format($product->getPrice(),2);
		  $res["discount"] = number_format($product->getFinalPrice(),2); //getDiscount();
		  $res["shipping"] = Mage::getStoreConfig('carriers/flatrate/price'); //$quote->getShippingAddress()->getShippingRatesCollection(); //$product->getShippingAmount();
		  $res["sprice"] = number_format($product->getSpecialprice(),2);
         }
		return($res); 
    }
    
     public function ws_currency ($store_id, $service) {
		  $res=array();
          $res["currentcurrency"] = Mage::app()->getStore($storeID)->getCurrentCurrencyCode();
          $res["basecurrency"] = Mage::app()->getStore($storeID)->getBaseCurrencyCode();
          $res["currentsymbol"] = Mage::app()->getLocale()->currency($res["currentcurrency"])->getSymbol();
          $res["basesymbol"] = Mage::app()->getLocale()->currency($res["basecurrency"])->getSymbol();
          return($res);
    }
    public function ws_createorder_old($storeId, $service, $custid, $pmethod, $transid, $Jproduct,$shippCharge) {
          
          $orderproduct = json_decode($Jproduct);
          //var_dump($Jproduct);
          $orderproductid = $orderproduct->id;
          $orderproductqty = $orderproduct->qty;
          //var_dump($orderproductid); 
          //var_dump($orderproductqty);
          
          //die;
          $id=$custid; // get Customer Id
         
          $customer = Mage::getModel('customer/customer')->load($id);

          $transaction = Mage::getModel('core/resource_transaction');
          $storeId = $customer->getStoreId();
          $reservedOrderId = Mage::getSingleton('eav/config')->getEntityType('order')->fetchNewIncrementId($storeId);

			$order = Mage::getModel('sales/order')
			->setIncrementId($reservedOrderId)
			->setStoreId($storeId)
			->setQuoteId(0)
			->setGlobal_currency_code('USD')
			->setBase_currency_code('USD')
			->setStore_currency_code('USD')
			->setOrder_currency_code('USD');

				// set Customer data
				$order->setCustomer_email($customer->getEmail())
				->setCustomerFirstname($customer->getFirstname())
				->setCustomerLastname($customer->getLastname())
				->setCustomerGroupId($customer->getGroupId())
				->setCustomer_is_guest(0)
				->setCustomer($customer);

			// set Billing Address
				$billing = $customer->getDefaultBillingAddress();
				$billingAddress = Mage::getModel('sales/order_address')
				->setStoreId($storeId)
				->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_BILLING)
				->setCustomerId($customer->getId())
				->setCustomerAddressId($customer->getDefaultBilling())
				->setCustomer_address_id($billing->getEntityId())
				->setPrefix($billing->getPrefix())
				->setFirstname($billing->getFirstname())
				->setMiddlename($billing->getMiddlename())
				->setLastname($billing->getLastname())
				->setSuffix($billing->getSuffix())
				->setCompany($billing->getCompany())
				->setStreet($billing->getStreet())
				->setCity($billing->getCity())
				->setCountry_id($billing->getCountryId())
				->setRegion($billing->getRegion())
				->setRegion_id($billing->getRegionId())
				->setPostcode($billing->getPostcode())
				->setTelephone($billing->getTelephone())
				->setFax($billing->getFax());
				$order->setBillingAddress($billingAddress);

				$shipping = $customer->getDefaultShippingAddress();
				$shippingAddress = Mage::getModel('sales/order_address')
				->setStoreId($storeId)
				->setAddressType(Mage_Sales_Model_Quote_Address::TYPE_SHIPPING)
				->setCustomerId($customer->getId())
				->setCustomerAddressId($customer->getDefaultShipping())
				->setCustomer_address_id($shipping->getEntityId())
				->setPrefix($shipping->getPrefix())
				->setFirstname($shipping->getFirstname())
				->setMiddlename($shipping->getMiddlename())
				->setLastname($shipping->getLastname())
				->setSuffix($shipping->getSuffix())
				->setCompany($shipping->getCompany())
				->setStreet($shipping->getStreet())
				->setCity($shipping->getCity())
				->setCountry_id($shipping->getCountryId())
				->setRegion($shipping->getRegion())
				->setRegion_id($shipping->getRegionId())
				->setPostcode($shipping->getPostcode())
				->setTelephone($shipping->getTelephone())
				->setFax($shipping->getFax());
                                //$order->collectShippingRates();
                                if($shippCharge==null || $shippCharge == "")
                                   $shippCharge=0;
				$ShippMessage = 'Order Placed From Mobile and Shipping Method Flatrate. Total Shipping Charge : ';
                                $order->setShippingAddress($shippingAddress)
				->setShipping_method('flatrate_flatrate')
                                ->setCollectShippingRates(true)
				->setShippingDescription($ShippMessage)
                                ->setFinalPriceWithHandlingFee($shippCharge)
                                ->setShippingAmount($shippCharge)
                                ->setBaseShippingAmount($shippCharge);
                                //Mage::getStoreConfig('carriers/flatrate/price');
                                // $order->setShippingAmount($shippCharge);
                                // $order->setBaseShippingAmount($shippCharge);
                if($pmethod == 'cashondelivery' || $pmethod == 'secureebs_standard' || $pmethod == 'authorizenet_directpost' ||$pmethod == 'checkmo' ) {
				     $orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId($transid)
				       ->setMethod($pmethod);
			    }
			    elseif($pmethod == 'paypal_standard') {
					$orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId($transid)
				       ->setLastTransId($transid)
				       ->setMethod($pmethod);
				       
				}
			    elseif($pmethod == 'purchaseorder') {
					$orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId($transid)
				       ->setPo_number($transid)
				       ->setMethod($pmethod);
			    }
			    else {
					//OTHER or UNKNOWN
					$orderPayment = Mage::getModel('sales/order_payment')
				       ->setStoreId($storeId)
				       ->setCustomerPaymentId(0)
				       ->setMethod($pmethod);
			    }

                               // $orderPayment->setShippingAmount($shippCharge);
                                //$orderPayment->setBaseShippingAmount($shippCharge);
				$order->setPayment($orderPayment);

				// let say, we have 2 products
				$subTotal = 0;
				
				$ind = 0;
				foreach($orderproductid as $poid) {
					$products[$poid] = array('qty'=> $orderproductqty[$ind]);
					$ind++;
			     }
				
				foreach ($products as $productId=>$product) {
				$_product = Mage::getModel('catalog/product')->load($productId);
				$rowTotal = $_product->getPrice() * $product['qty'];
				$orderItem = Mage::getModel('sales/order_item')
				->setStoreId($storeId)
				->setQuoteItemId(0)
				->setQuoteParentItemId(NULL)
				->setProductId($productId)
				->setProductType($_product->getTypeId())
				->setQtyBackordered(NULL)
				->setTotalQtyOrdered($product['rqty'])
				->setQtyOrdered($product['qty'])
				->setName($_product->getName())
				->setSku($_product->getSku())
				->setPrice($_product->getPrice())
				->setBasePrice($_product->getPrice())
				->setOriginalPrice($_product->getPrice())
				->setRowTotal($rowTotal)
				->setBaseRowTotal($rowTotal);
			        	
				//Update new quantity
				$newqty = (int)(Mage::getModel('cataloginventory/stock_item')->loadByProduct($productId)->getQty())-(int)$product['qty'];
				Mage::getModel('cataloginventory/stock_item')->loadByProduct($productId)->setQty($newqty)->save();
                
                                $subTotal += $rowTotal;
				$order->addItem($orderItem);
				}

				$order->setSubtotal($subTotal)
				->setBaseSubtotal($subTotal)
				->setGrandTotal($subTotal+$shippCharge)
				->setBaseGrandTotal($subTotal+$shippCharge);
                                
				try {
                                $order->getPayment()->setIsTransactionClosed(1);
                                $order->getPayment()->setTransactionAdditionalInfo(Mage_Sales_Model_Order_Payment_Transaction::RAW_DETAILS,array('TransactionID'=>$transid,'key2'=>'value2')); 
				$order->setTransId($transid);
				$transaction->addObject($order);
				$transaction->addCommitCallback(array($order, 'place'));
				$transaction->addCommitCallback(array($order, 'save'));
				$transaction->save();
			    }
			    catch(Exception $ex) {
					echo $ex;
				}
				//$order->setFinalPriceWithHandlingFee($shippCharge);
                                $order->sendNewOrderEmail();
                                $order->getPayment()->setTransactionId($transid);

if ($pmethod == 'paypal_standard') {
    $orderIdpp = $order->getId();
    $orderpaypal = Mage::getModel('sales/order')->load($orderIdpp);
    $orderpaypal->setState(Mage_Sales_Model_Order::STATE_PROCESSING, true)->save();
}

                                $res=array();
                                $res["id"] = $order->getId();
                                $res["orderid"] = $order->getIncrementId();
				$res["transid"] = $order->getPayment()->getTransactionId();
				return $res;
	}	
    public function ws_setaddress($store, $service, $customerId, $JbillAdd, $JshippAdd) {
	       //----------------------------------------------------------------------
	       $billAdd = json_decode($JbillAdd);
	       $shippAdd = json_decode($JshippAdd);
	       //var_dump($billAdd); 
	       //var_dump($shippAdd); die;
	       $result = array();
	       $result['billaddress'] = 0;
           $result['shippaddress'] = 0; 
          $_bill_address = array (
                 'firstname' => $billAdd->billfname,
                 'lastname' => $billAdd->billlname,
                 'street' => array (
                      '0' => $billAdd->billstreet1,
                      '1' => $billAdd->billstreet2,
                  ),
                  'city' => $billAdd->billcity,
                  'region_id' => '',
                  'region' => $billAdd->billstate,
                  'postcode' => $billAdd->billpostcode,
                  'country_id' => $billAdd->billcountry, 
                  'telephone' => $billAdd->billphone,
          );
          $_shipp_address = array (
                 'firstname' => $shippAdd->shippfname,
                 'lastname' => $shippAdd->shipplname,
                 'street' => array (
                      '0' => $shippAdd->shippstreet1,
                      '1' => $shippAdd->shippstreet2,
                  ),
                  'city' => $shippAdd->shippcity,
                  'region_id' => '',
                  'region' => $shippAdd->shippstate,
                  'postcode' => $shippAdd->shipppostcode,
                  'country_id' => $shippAdd->shippcountry, 
                  'telephone' => $shippAdd->shippphone,
          );
          $billAddress = Mage::getModel('customer/address');
          $billAddress->setData($_bill_address)
                        ->setCustomerId($customerId)
                        ->setIsDefaultBilling('1')
                        ->setSaveInAddressBook('1');
                        
          $shippAddress = Mage::getModel('customer/address');
          $shippAddress->setData($_shipp_address)
                        ->setCustomerId($customerId)
                        ->setIsDefaultShipping('1')
                        ->setSaveInAddressBook('1');              
                        
          try {
			  
			if(count(json_decode($JbillAdd,true))>0) {
				  if($billAddress->save())
					 $result['billaddress'] = 1;
              }
              if(count(json_decode($JshippAdd,true))>0) {
				  if($shippAddress->save())
					 $result['shippaddress'] = 1;              
			  }	
          }
          catch (Exception $ex) {
              //Zend_Debug::dump($ex->getMessage());
          }
          return $result;
         //---------------------------------------------------------------------
    }
     public function ws_storedetails($store, $service) {
		 $res = array();
		 try {
		     $res["store"] = Mage::app()->getStore($store);
		     Mage::app()->setCurrentStore($store);
                     $res["storeid"] = Mage::app()->getStore($store)->getStoreId();
		     $res["storecode"] = Mage::app()->getStore($store)->getCode();
		     $res["storewebid"] = Mage::app()->getStore($store)->getWebsiteId();
		     $res["storename"] = Mage::app()->getStore($store)->getName();
		     $res["storeactive"] = Mage::app()->getStore($store)->getIsActive();
		     $res["rooturl"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB); 		     
		     $res["storeurl"] = Mage::helper('core/url')->getHomeUrl(); 
		     $res["storelogo_alt"] = Mage::getStoreConfig('design/header/logo_alt');//Mage::getLogoSrc();
		     
		     $res["storefrontname"] = Mage::app()->getStore($store)->getFrontendName(); //getLogoSrc()		     
		     $res["current_url"] = Mage::helper('core/url')->getCurrentUrl();
             $res["media_url1"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_LINK);
			 $res["media_url2"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_MEDIA);
			 $res["skin_url"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_SKIN);
			 $res["js_url"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_JS);			 
		     $res["storelogo"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_SKIN).'frontend/default/default/'.Mage::getStoreConfig('design/header/logo_src');
			 $res["storebanner"] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_SKIN).'frontend/default/default/images/banner.png';
                         $res["storeadminname"] = Mage::getStoreConfig('trans_email/ident_sales/name');
                         $res["storeemail"] = Mage::getStoreConfig('trans_email/ident_sales/email');			 
		 }
		 catch(Exception $ex) {
			 echo $ex;
		 }
		 return $res;
     }
     public function ws_search($store, $service, $search_data) {
                 
            $res = array();
            try {
                                  
                 // Code to Search Product by $searchstring and get Product IDs
                 $product_collection = Mage::getResourceModel('catalog/product_collection')
                  ->addAttributeToSelect('*')
                  ->addAttributeToFilter('name', array('like' => '%'.$search_data.'%'))
                  ->addStoreFilter($store)
                  ->addFieldToFilter('status', 1)
                  ->load();

                 foreach ($product_collection as $_product) {
                 if( $_product->getStoreId() == $store) {
                         $res[] = array(
                               "id" => $_product->getId(),
                               "name" => $_product->getName(),
                               "imageurl" => Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$_product->getImage(),
                               "sku" => $_product->getSku(),
                               "spclprice" => number_format($_product->getSpecialprice(),2),
                               "price" => number_format($_product->getPrice(),2),
                               "created_date" => $_product->getCreatedAt(),
                               "is_in_stock" => $_product->getStockItem()->getIsInStock(),
                               "stock_quantity" => Mage::getModel('cataloginventory/stock_item')->loadByProduct($_product->getId())->getQty()
                               );
                       }
                  }

          }
          catch(Exception $ex) {
                echo $ex;
          }
          return $res;
     }
     public function send_Password_Mail_to_NewUser($user, $pswd, $email) {
		  
		//load the custom template to the email							   
		$emailTemplate = Mage::getModel('core/email_template')->loadDefault('mofluid_password');	   
		// it depends on the template variables
		$emailTemplateVariables = array();	
		$emailTemplateVariables['user'] = $user;
		$emailTemplateVariables['password'] = $pswd;  
		$emailTemplateVariables['email'] = $email;  

		$emailTemplate->setSenderName('Mofluid');
		$emailTemplate->setSenderEmail(Mage::getStoreConfig('trans_email/ident_general/email'));
		$emailTemplate->setType('html');
		$emailTemplate->setTemplateSubject('Mofluid New Account Password');
		$emailTemplate->send($email, "Mofluid", $emailTemplateVariables);     
          
    }
    public function ws_myOrder($cust_id) {
	       $res = array();
           $orders = Mage::getResourceModel('sales/order_collection')
                     ->addFieldToSelect('*')
                     ->addFieldToFilter('customer_id', $cust_id)
                     ->setOrder('created_at', 'desc');   
                    //$this->setOrders($orders); 
           foreach ($orders as $order) {
                $shippingAddress = $order->getShippingAddress();
                if(is_object($shippingAddress)) {
					$shippadd = array();
					$shippadd = array(
						 "firstname" => $shippingAddress->getFirstname(),
						 "lastname" => $shippingAddress->getLastname(),
						 "company" => $shippingAddress->getCompany(),
						 "street" => $shippingAddress->getStreetFull(),
						 "region" => $shippingAddress->getRegion(),
						 "city" => $shippingAddress->getCity(),
						 "pincode" => $shippingAddress->getPostcode(),
						 "countryid" => $shippingAddress->getCountry_id(),
						 "contactno" => $shippingAddress->getTelephone()
					); 
                }
                $billingAddress = $order->getBillingAddress();
                if(is_object($billingAddress)) {
					$billadd = array();
					$billadd = array(
						 "firstname" => $billingAddress->getFirstname(),
						 "lastname" => $billingAddress->getLastname(),
						 "company" => $billingAddress->getCompany(),
						 "street" => $billingAddress->getStreetFull(),
						 "region" => $billingAddress->getRegion(),
						 "city" => $billingAddress->getCity(),
						 "pincode" => $billingAddress->getPostcode(),
						 "countryid" => $billingAddress->getCountry_id(),
						 "contactno" => $billingAddress->getTelephone()
					);
                }
                $payment = array();
                $payment = $order->getPayment();
                try {
					$payment = array (
						  "payment_method" => $payment->getMethodInstance()->getTitle(), 
						  "payment_method_code" => $payment->getMethodInstance()->getCode()
					);
                }
                catch(Exception $ex2) {
					
				}
                //$order = Mage::getModel('sales/order')->load($order_id);
                $items = $order->getAllItems();
                $itemcount=count($items);
                $name=array();
                $unitPrice=array();
                $sku=array();
                $ids=array();
                $qty=array();
                $images = array();
                foreach ($items as $itemId => $item) {
                     $name[] = $item->getName();
                     $unitPrice[]=$item->getPrice();
                     $sku[]=$item->getSku();
                     $ids[]=$item->getProductId();
                     $qty[]=$item->getQtyToInvoice();
                     $products = Mage::getModel('catalog/product')->load($item->getProductId());
                     $images[] = Mage::getBaseUrl(Mage_Core_Model_Store::URL_TYPE_WEB).'/media/catalog/product'.$products->getThumbnail();
                }

                $product = array();
                $product = array (
                     "name" => $name,
                     "sku" => $sku,
                     "id" => $ids,
                     "quantity" => $qty,
                     "unitprice" => $unitPrice,
                     "image" => $images,
                     "total_item_count" => $itemcount
                );
                $order_date = $order->getCreatedAtStoreDate().'';
                $orderData = array(
                     "id" => $order->getId(),
                     "order_id" => $order->getRealOrderId(),
                     "status" => $order->getStatus(),
                     "order_date" => $order_date,
                     "grand_total" => $order->getGrandTotal(),
                     "shipping_address" => $shippadd,
                     "billing_address" => $billadd,
                     "shipping_message" => $order->getShippingDescription(),
                     "shipping_amount" => $order->getShippingAmount(),
                     "payment_method" => $payment,
                     "product" => $product,
                     "couponUsed" => 0
                );
                $couponCode = $order->getCouponCode();
                if($couponCode!="") {					
					$orderData["couponUsed"] =  1;
					$orderData["couponCode"] =  $couponCode;
				    $orderData["discount_amount"] = $order->getDiscountAmount()*(-1);
				}
				$res[] = $orderData;
           }
           return $res;
    }
    public function ws_myProfile($cust_id) {
         try {
              $customer = Mage::getModel('customer/customer')->load($cust_id);
              $customerData = $customer->getData();
              $customerData['membersince'] =  Mage::getModel('core/date')->date("Y-m-d h:i:s A",  $customerData['created_at']);
              $shippingAddress = $customer->getDefaultShippingAddress();
         }
         catch(Exception $ex2) {
              echo $ex2;
         }
         $shippadd = array();
         $billadd = array();
         try {
              if($shippingAddress!=null) {
                   $shippadd = array(
                       "firstname" => $shippingAddress->getFirstname(),
                       "lastname" => $shippingAddress->getLastname(),
                       "company" => $shippingAddress->getCompany(),
                       "street" => $shippingAddress->getStreetFull(),
                       "region" => $shippingAddress->getRegion(),
                       "city" => $shippingAddress->getCity(),
                       "pincode" => $shippingAddress->getPostcode(),
                       "countryid" => $shippingAddress->getCountry_id(),
                       "contactno" => $shippingAddress->getTelephone()
                   );
              }
              $billingAddress = $customer->getDefaultBillingAddress();
              if($billingAddress!=null){
                   $billadd = array(
                       "firstname" => $billingAddress->getFirstname(),
                       "lastname" => $billingAddress->getLastname(),
                       "company" => $billingAddress->getCompany(),
                       "street" => $billingAddress->getStreetFull(),
                       "region" => $billingAddress->getRegion(),
                       "city" => $billingAddress->getCity(),
                       "pincode" => $billingAddress->getPostcode(),
                       "countryid" => $billingAddress->getCountry_id(),
                       "contactno" => $billingAddress->getTelephone()
                   ); 
              }
         }
         catch(Exception $ex) {
              echo $ex; 
         }
         $res = array();
         $res = array(
              "CustomerInfo" => $customerData,
              "BillingAddress" => $billadd,
              "ShippingAddress" => $shippadd
         );
         return $res;
   }
    public function ws_changeProfilePassword($custid, $username, $oldpassword, $newpassword, $store) {
        $res = array();
        $validate = 0;
        $websiteId = Mage::getModel('core/store')->load($store)->getWebsiteId();
        try {
             $login_customer_result = Mage::getModel('customer/customer')->setWebsiteId($websiteId)->authenticate($username, $oldpassword);
             $validate = 1;
        }
        catch(Exception $ex) {
             $validate = 0;
        }
        if($validate == 1) {
             try {
                  $customer = Mage::getModel('customer/customer')->load($custid);
                  $customer->setPassword($newpassword);
                  $customer->save();    
                  $res = array (
                       "customerid" => $custid,
                       "oldpassword" => $oldpassword,
                       "newpassword" => $newpassword,
                       "change_status" => 1,
                       "message" => 'Your Password has been Changed Successfully'
                  );
             }
             catch(Exception $ex) {
                  $res = array (
                       "customerid" => $custid,
                       "oldpassword" => $oldpassword,
                       "newpassword" => $newpassword,
                       "change_status" => -1,
                       "message" => 'Error : '.$ex->getMessage
                  );
             }
        }
        else {
            $res = array (
                 "customerid" => $custid,
                 "oldpassword" => $oldpassword,
                 "newpassword" => $newpassword,
                 "change_status" => 0,
                 "message" => 'Incorrect Old Password.'
            );
        }
        return $res;
    }

 public function ws_setprofile($store, $service, $customerId, $JbillAdd, $JshippAdd,$profile) {

 //----------------------------------------------------------------------
	       $billAdd = json_decode($JbillAdd);
	       $shippAdd = json_decode($JshippAdd);
	       $profile = json_decode($profile);
	       
	       $result = array();
	       $result['billaddress'] = 0;
               $result['shippaddress'] = 0; 
               $result['userprofile'] = 0; 
                       
            /* Update User Profile Data */
              
            $customer = Mage::getModel('customer/customer')
					   ->setWebsiteId(Mage::app()->getStore()->getWebsiteId())
                       ->loadByEmail($profile->email);
                
              //check exists email address of users  
             if ($customer->getId() && $customer->getId()!=$customerId) {
				return $result;
		     } 
            else { 
				$_bill_address = array (
					 'firstname' => $billAdd->billfname,
					 'lastname' => $billAdd->billlname,
					 'street' => array (
						  '0' => $billAdd->billstreet1,
						  '1' => $billAdd->billstreet2,
					  ),
					  'city' => $billAdd->billcity,
					  'region_id' => '',
					  'region' => $billAdd->billstate,
					  'postcode' => $billAdd->billpostcode,
					  'country_id' => $billAdd->billcountry, 
					  'telephone' => $billAdd->billphone,
				   );
				  $_shipp_address = array (
					 'firstname' => $shippAdd->shippfname,
					 'lastname' => $shippAdd->shipplname,
					 'street' => array (
						  '0' => $shippAdd->shippstreet1,
						  '1' => $shippAdd->shippstreet2,
					  ),
					  'city' => $shippAdd->shippcity,
					  'region_id' => '',
					  'region' => $shippAdd->shippstate,
					  'postcode' => $shippAdd->shipppostcode,
					  'country_id' => $shippAdd->shippcountry, 
					  'telephone' => $shippAdd->shippphone,
			  );
			  $billAddress = Mage::getModel('customer/address');
			  $billAddress->setData($_bill_address)
							->setCustomerId($customerId)
							->setIsDefaultBilling('1')
							->setSaveInAddressBook('1');
							
			  $shippAddress = Mage::getModel('customer/address');
			  $shippAddress->setData($_shipp_address)
							->setCustomerId($customerId)
							->setIsDefaultShipping('1')
							->setSaveInAddressBook('1');             
								
							
			  try {
				  if($billAddress->save())
					 $result['billaddress'] = 1;
				  if($shippAddress->save())
					 $result['shippaddress'] = 1;          
					  
					$write = Mage::getSingleton("core/resource")->getConnection("core_write");
					$sql1 = "update `customer_entity` set `email` = '".$profile->email."' where`entity_id` =".$customerId;
					$attributeModel1 = Mage::getModel('eav/entity_attribute')->loadByCode("customer", "firstname");
					$firstnameId = $attributeModel1->getAttributeId();
					$attributeModel2 = Mage::getModel('eav/entity_attribute')->loadByCode("customer", "lastname");
					$lastnameId = $attributeModel2->getAttributeId();
					$sql2 = "update `customer_entity_varchar` set `value` = '".$profile->fname."' where `entity_type_id` =1 AND `attribute_id`=".$firstnameId." AND `entity_id`=".$customerId;
					$sql3 = "update `customer_entity_varchar` set `value` = '".$profile->lname."' where `entity_type_id` =1 AND `attribute_id`=".$lastnameId." AND `entity_id`=".$customerId;

					if($write->query($sql1) && $write->query($sql2) && $write->query($sql3)) {
					  $result['userprofile'] = 1;           
					}                
			  }
			  catch (Exception $ex) {
				  Zend_Debug::dump($ex->getMessage());
			  }
			  return $result;
		 }
         //---------------------------------------------------------------------
    
}
	public function ws_forgotPassword($email="") {
         $res=array();
         $res["response"] = "error";
         
         if ($email) {            
            /** @var $customer Mage_Customer_Model_Customer */
            $customer = Mage::getModel('customer/customer')
                ->setWebsiteId(Mage::app()->getStore()->getWebsiteId())
                ->loadByEmail($email);

            if ($customer->getId()) {
                try {
                    $newResetPasswordLinkToken = Mage::helper('customer')->generateResetPasswordLinkToken();
                    $customer->changeResetPasswordLinkToken($newResetPasswordLinkToken);
                    $customer->sendPasswordResetConfirmationEmail();
                    $res["response"] = "success";
                } catch (Exception $exception) {
                   // $this->_getSession()->addError($exception->getMessage());        
                }
            }       
            
        } 
         return($res);
     }
    public function _getSession()
    {
        return Mage::getSingleton('customer/session');
    }

    function mofluid_register_push($store, $deviceid, $pushtoken, $platform, $appname, $description) {
    		$res = array();
    		try {
    		      $mofluid_push = Mage::getSingleton('core/resource')->getConnection('core_write');
                $readresult=$mofluid_push->query("SELECT * FROM  mofluidpush WHERE device_id = '".$deviceid."' AND app_name = '".$appname."' AND platform ='".$platform."'");
                $row = $readresult->fetch() ;
                $readresult2 = $mofluid_push->query("SELECT * FROM  mofluidpush WHERE push_token_id = '".$pushtoken."' AND app_name = '".$appname."' AND platform ='".$platform."'");
                $row = $readresult->fetch();
                $row2 = $readresult2->fetch();

               if($row["device_id"]) {
                        $mofluid_push->query("DELETE FROM  mofluidpush WHERE device_id = '".$deviceid."' AND app_name = '".$appname."' AND platform ='".$platform."'");
                        $mofluid_push->query("insert into mofluidpush (mofluidadmin_id, device_id, push_token_id, platform, app_name, description) 
                                                                      values (1,'".$deviceid."','".$pushtoken."','".$platform."','".$appname."','".$description."')");
                        $res= array ("status" => "update","deviceid" => $deviceid,"pushtoken" => $pushtoken,"message" =>"Update token for the existing device id.");
                }
else if($row2["push_token_id"]) {
$mofluid_push->query("DELETE FROM  mofluidpush WHERE push_token_id = '".$pushtoken."' AND app_name = '".$appname."' AND platform ='".$platform."'");
                        $mofluid_push->query("insert into mofluidpush (mofluidadmin_id, device_id, push_token_id, platform, app_name, description) 
                                                                      values (1,'".$deviceid."','".$pushtoken."','".$platform."','".$appname."','".$description."')");
                        $res= array ("status" => "update","deviceid" => $deviceid,"pushtoken" => $pushtoken,"message" =>"Update Device for the existing token id.");

}
                else {
                        $mofluid_push->query("insert into mofluidpush (mofluidadmin_id, device_id, push_token_id, platform, app_name, description) 
                                                                      values (1,'".$deviceid."','".$pushtoken."','".$platform."','".$appname."','".$description."')");
                         $res= array ("status" => "register","deviceid" => $deviceid,"pushtoken" => $pushtoken,"message" =>"register device id with new token.");
                }
          }
          catch(Exception $ex) {
                $res= array ("status" => "error","deviceid" => $deviceid,"pushtoken" => $pushtoken,"message" =>$ex->getMessage());
          }
          return $res;
    }

	     public function ws_termCondition($store) {
        $flag = Mage::getStoreConfigFlag('checkout/options/enable_agreements');
        if($flag) {
            $agreements = Mage::getModel('checkout/agreement')->getCollection()
                      ->addStoreFilter($store)
                      ->addFieldToFilter('is_active', 1);
           $data=  $agreements->getData('agreements');
           return $data;
        }
           
      }
      public function ws_productQuantity($product) {
        $pqty = array();
        $product = json_decode($product);       
        foreach ($product as $key => $val) {             
             try {  
                    $model = Mage::getModel('catalog/product'); 
                    $_product = $model->load($val);             
                    $stocklevel = (int)Mage::getModel('cataloginventory/stock_item')
                                             ->loadByProduct($_product)->getQty();          
                    $pqty[$val] = $stocklevel;
                }catch(Exception $ex) {

                }
          }        
          return $pqty;
        }
 	public function ws_countryList($store_id,$paymentgateway,$pmethod) {

       		$country = array();
		  if($paymentgateway=="paypal" && $pmethod=="standard")	 {
			  $allowspecific =  Mage::getConfig()->getNode('default/payment/paypal_standard/allowspecific');
			 
			  // get specific countries of standard paypal method from config table
			  if($allowspecific==1) {
				  $_countries =  Mage::getConfig()->getNode('default/payment/paypal_standard/specificcountry');
				  $data = explode(",",$_countries[0]); 
				  if (count($data) > 0) {
					  foreach($data as $key=>$country_code) {
						 $country[$country_code] = Mage::app()->getLocale()->getCountryTranslation($country_code);
					   }
				  }        
			  }else {
				$_countries = Mage::getResourceModel('directory/country_collection')
							 ->loadData()
							 ->toOptionArray(false);
          
				 if (count($_countries) > 0) {
					foreach($_countries as $_country) {
						$country[$_country['value']]  = $_country['label'];
					}
				  }
			    }
		  }	 // end of outer if 
         	return($country);
	 } 
	 
	//************ list all enable shipping method ********** //
	 
	public function ws_listShipping()
	{
		$methods = Mage::getSingleton('shipping/config')->getActiveCarriers();
		$shipping = array();
		foreach($methods as $_ccode => $_carrier) {
			if($_methods = $_carrier->getAllowedMethods())  {
				if(!$_title = Mage::getStoreConfig("carriers/$_ccode/title"))
				$_title = $_ccode;
				foreach($_methods as $_mcode => $_method)   {
					$_code = $_ccode . '_' . $_mcode;
					$shipping[$_code]=array('method' => $_method,'title' => $_title);
				}
			}
		}
		return $shipping; 
	}
	
	/*====================      Service to create order with Coupon Code  =================*/ 
	public function ws_createorder($storeId, $service, $custid, $pmethod, $smethod, $transid, $Jproduct, $shippCharge, $couponCode, $grand_amount, $order_sub_amount, $discount_amount) {		
		
		$orderproduct = json_decode($Jproduct);
		$customerObj = Mage::getModel('customer/customer')->load($custid);		
		// get default billing and shipping address of customer
		$shipping = $customerObj->getDefaultShippingAddress();
		if(is_object($shipping)) {
			$shippingAddress = array(
				'prefix' => $shipping->getPrefix(),
				'firstname' => $shipping->getFirstname(),
				'lastname' => $shipping->getLastname(),
				'company' => $shipping->getCompany(),
				'street' => $shipping->getStreet(),
				'city' => $shipping->getCity(),
				'postcode' => $shipping->getPostcode(),
				'telephone' => $shipping->getTelephone(),
				'country_id' =>$shipping->getCountryId(),
				'region_id' =>$shipping->getRegionId()
					
			);	
		}else {
			$res["status"] = 0;
			return $res;
		}
		$billing = $customerObj->getDefaultBillingAddress();
		if(is_object($billing)) {
			$billingAddress = array(
				'prefix' => $billing->getPrefix(),
				'firstname' => $billing->getFirstname(),
				'lastname' => $billing->getLastname(),
				'company' => $billing->getCompany(),
				'street' => $billing->getStreet(),
				'city' => $billing->getCity(),
				'postcode' => $billing->getPostcode(),
				'telephone' => $billing->getTelephone(),
				'country_id' =>$billing->getCountryId(),
				'region_id' =>$billing->getRegionId()
			);
		}else {
			$res["status"] = 0;
			return $res;
		}
		$quote = Mage::getModel('sales/quote');
		$customer = Mage::getModel('customer/customer')->load($custid);
		$quote->assignCustomer($customer);
		$quote->setStore(Mage::app()->getStore());	
		
		//  add cart items	
		foreach($orderproduct->id as $key=>$item) {    
			$product = Mage::getModel('catalog/product'); 
			$product->load($item);
			$quoteItem = Mage::getModel('sales/quote_item')->setProduct($product);
			$quoteItem->setQuote($quote);
			$quoteItem->setQty($orderproduct->qty[$key]);
			$quote->addItem($quoteItem);
		}

		$addressForm = Mage::getModel('customer/form');
		$addressForm->setFormCode('customer_address_edit')
					->setEntityType('customer_address');
		foreach ($addressForm->getAttributes() as $attribute) {
			if (isset($shippingAddress[$attribute->getAttributeCode()])) {
				$quote->getShippingAddress()->setData($attribute->getAttributeCode(), $shippingAddress[$attribute->getAttributeCode()]);
			}
		}
		foreach ($addressForm->getAttributes() as $attribute) {
			if (isset($billingAddress[$attribute->getAttributeCode()])) {
				$quote->getBillingAddress()->setData($attribute->getAttributeCode(), $billingAddress[$attribute->getAttributeCode()]);
			}
		}	
		
		// coupon code
		if(!empty($couponCode)) $quote->setCouponCode($couponCode); 

		// shipping method an collect
		$ShippMessage = 'Order Placed From Mobile and Shipping Method Flatrate. Total Shipping Charge : ';
		
		if($smethod=="freeshipping_freeshipping") {
			$quote->getShippingAddress()
				  ->setFreeShipping(true)
				  ->setCollectShippingRates(true)->collectShippingRates()					
				  ->setShippingMethod($smethod);
		}else if($smethod=="tablerate_bestway") {
			$quote->getShippingAddress()
				  ->setCollectShippingRates(true)->collectShippingRates()
                  ->setShouldIgnoreValidation(true)->setShippingMethod($smethod)
                  ->setShippingDescription('Table Rate - Best Way');

		}
		else {
		
	$quote->getShippingAddress()
				  ->setShippingDescription($ShippMessage)
				  ->setCollectShippingRates(true)->collectShippingRates()					
				  ->setShippingMethod($smethod)
				  ->setShippingAmount($shippCharge)
				  ->setBaseShippingAmount($shippCharge);	
		}	
	
	
		$quote->collectTotals();    
		$quote->save();
		$items = $quote->getAllItems();
		$quote->reserveOrderId();
		// add payment method  in Quote
		$quotePayment = $quote->getPayment(); // Mage_Sales_Model_Quote_Payment
		$quotePayment->setMethod($pmethod)
					 ->setIsTransactionClosed(1)
                     ->setTransactionAdditionalInfo(Mage_Sales_Model_Order_Payment_Transaction::RAW_DETAILS,array('TransactionID'=>$transid,'key2'=>'value2')); 							
		if($pmethod == 'cashondelivery' || $pmethod == 'secureebs_standard' || $pmethod == 'authorizenet_directpost' ||$pmethod == 'checkmo' ) {
			$quotePayment->setCustomerPaymentId($transid);
		}
		elseif($pmethod == 'paypal_standard') {
			$quotePayment->setCustomerPaymentId($transid)->setLastTransId($transid);
		}
		elseif($pmethod == 'purchaseorder') {
			$quotePayment->setCustomerPaymentId($transid)->setPo_number($transid);
		}
		else {
			$quotePayment->setCustomerPaymentId(0);
		}
		$quote->setPayment($quotePayment);
		$convertQuote = Mage::getSingleton('sales/convert_quote');
		$order = $convertQuote->addressToOrder($quote->getShippingAddress());
		$orderPayment = $convertQuote->paymentToOrderPayment($quotePayment);
		$order->setBillingAddress($convertQuote->addressToOrderAddress($quote->getBillingAddress()));
		$order->setShippingAddress($convertQuote->addressToOrderAddress($quote->getShippingAddress()));
		$order->setPayment($convertQuote->paymentToOrderPayment($quote->getPayment()));
if($smethod=="tablerate_bestway") {
    $order->setShippingAmount($shippCharge);
    $order->setBaseShippingAmount($shippCharge);
    $order->setSubtotal($order_sub_amount)
          ->setBaseSubtotal($order_sub_amount)
          ->setGrandTotal($grand_amount)
          ->setBaseGrandTotal($grand_amount)
         ->setDiscountAmount($discount_amount);

}

		// conver Quote to Order
		foreach ($items as $item) {
			$orderItem = $convertQuote->itemToOrderItem($item);
			if ($item->getParentItem()) {
				$orderItem->setParentItem($order->getItemByQuoteItemId($item->getParentItem()->getId()));
			}
			$order->addItem($orderItem);
		}


		try {
			$order->setTransId($transid);
			//$order->place();
			//$order->save(); 
			$transaction = Mage::getModel('core/resource_transaction');
			$transaction->addObject($order);
			$transaction->addCommitCallback(array($order, 'place'));
			$transaction->addCommitCallback(array($order, 'save'));
			$transaction->save();
		} catch (Exception $e){        
			Mage::log($e->getMessage());
		}
				
		$order->getPayment()->setTransactionId($transid);
		$last_order_increment_id = Mage::getModel("sales/order")->getCollection()->getLastItem()->getIncrementId();
				
		if ($pmethod == 'paypal_standard') {
			$orderIdpp = $order->getId();
			$orderpaypal = Mage::getModel('sales/order')->load($orderIdpp);
			$orderpaypal->setState(Mage_Sales_Model_Order::STATE_PROCESSING, true)->save();
		}
		$res=array();
		$res["status"] = 1;
		$res["id"] = $order->getId();
		$res["orderid"] = $order->getIncrementId();
		$res["transid"] = $order->getPayment()->getTransactionId();
		
		if($res["orderid"]>0 && $pmethod=="cashondelivery")
		$this->ws_sendorderemail($res["orderid"]);
		
		return $res;
	}
	
	/*====================      Service to check ship2myid module availability   =================*/ 
    public function ws_shipmyidenabled() {
		$res = array();		
		$res["result"] = 0;
		if(Mage::getStoreConfig('clm24core/shippings/enabled')) {
			$res["result"] = 1;
		}
		return $res;
	}	
	/*====================     Validate Coupon Code for per User  =================*/ 
	public function ws_validateCoupon($couponCode, $custid) {		
		$res = array();		
		$res["result"] = 0;
		$coupon = Mage::getModel('salesrule/coupon')->load($couponCode, 'code');
		$oRule = Mage::getModel('salesrule/rule')->load($coupon->getRuleId());
		$couponDetails = $oRule->getData();	
		if($coupon->getId()>0 && $couponDetails["is_active"]==1){
			$count = 0;
			$flag = 0;
			$today = date("Y-m-d"); 			
			if($custid!="" && is_numeric($custid)) {
			    $exist_customer = Mage::getModel("customer/customer")->load($custid);
				if($exist_customer->getId()>0) {
					$flag = 1;
					$orders = Mage::getResourceModel('sales/order_collection')
								->addFieldToSelect('*')
								->addFieldToFilter('customer_id', $custid)
								->setOrder('created_at', 'desc');				
					foreach ($orders as $order) {
						if(strtolower($order->getCouponCode())==strtolower($couponCode))
						$count++;
					}
				}
			}
					
			if($coupon->times_used>=$coupon->usage_limit || $coupon->expiration_date<$today || ($flag==1 && $count>=$coupon->usage_per_customer))
				$res["result"] = 0;
			else
				$res["result"] = 1;
			
		}	
		return $res;
	} 
	/*====================     Get Coupon Details  =================*/ 
	public function ws_couponDetails($couponCode) {		
		$res = array();		
		$coupon = Mage::getModel('salesrule/coupon')->load($couponCode, 'code');
		$res["status"] = 0;
		if($coupon->getId()>0){
			$oRule = Mage::getModel('salesrule/rule')->load($coupon->getRuleId());
			$couponDetails = $oRule->getData();
			//echo "<pre>"; print_r($couponDetails); die; 
			$res["coupon_code"] = $couponDetails["coupon_code"];
			$res["is_active"] = $couponDetails["is_active"];
			$res["simple_action"] = $couponDetails["simple_action"];
			$res["discount_amount"] = $couponDetails["discount_amount"];
			$res["discount_qty"] = $couponDetails["discount_qty"];
			$res["apply_to_shipping"] = $couponDetails["apply_to_shipping"];
			$res["coupon_code"] = $couponDetails["coupon_code"];
			$res["times_used"] = $coupon->times_used;
			$model = Mage::registry('current_promo_quote_rule');
			$clm24myidCouponModel = Mage::getModel('myidshipping/coupon')->loadByRuleId($coupon->getRuleId());
            $shipFlag = $clm24myidCouponModel->getShip2myidOnly();
            if($shipFlag=="")
            $shipFlag = 0;
            $res["shipmyidonly"] = $shipFlag;	
			$res["status"] = 1;
		}	
		return $res;
	} 
	
	 /*====================      Service to send order email after successfull payment of paypal   =================*/ 
     public function ws_sendorderemail($orderid) {		 
		 $result["result"] = 0;
		 if($orderid>0) {
		  try {				
				$order = Mage::getModel('sales/order');
				//$order = Mage::getModel('myidshipping/order');
				$order->loadByIncrementId($orderid);
				//echo "<pre>"; print_r($order); die;
				if($order->email_sent!=1) {
					$order->setState(Mage_Sales_Model_Order::STATE_PROCESSING, true, 'Gateway has authorized the payment.');
					$order->sendNewOrderEmail("app");
					$order->setEmailSent(true);
					$result["result"] = 1;
				}
			} catch (Exception $ex) {
				//echo $ex->getMessage(); 
			}
		 }	
			return $result;
     }
      /*====================  Service to fetch all product of Store =================*/ 
      public function ws_productSearchHelp($store_id) {
          $res = array();
          try {
              $collection = Mage::getResourceModel('catalog/product_collection')
                            ->addAttributeToSelect('name')
							->addAttributeToSelect('id')
                            ->addStoreFilter($store_id)
                            ->addAttributeToFilter('status', 1)
							->addAttributeToFilter('visibility', 4)
                            ->load();            
              foreach ($collection as $_product) {
                      $res[] = array(
                               "id" => $_product->getId(),
                               "name" => $_product->getName(),
                      );
              }
          }
          catch(Exception $ex) {
              $res = $ex->getMessage();
          }  
          return($res);
    }
	//************ list all enable shipping method ********** //
	public function ws_getShippingDetail($pid,$address) {

		$res=array();
		$add=array();
		$_code="";
		$id_counter = 0;
		$pid=json_decode($pid); //recieve pid
		$address=json_decode($address); //recieve address
		$address_counter=0;

		//fetch the address record
		foreach($address as $add_key => $add_value){
			try{
				$add[$id_counter][$add_key]= $add_value;
			}
			catch(Exception $err){
			}
		}
		$dest_country=$add[0]['dest_country'];
		$dest_region=$add[0]['dest_region'];
		$dest_zip=$add[0]['dest_zip'];
					           
		$weight_sum=0;
		$quantity_sum=0;
		$price_sum=0;	            
		//set the loop for particular product id
		foreach($pid as $product_id => $quantity){
			$productsCollection = Mage::getModel('catalog/product')
            		                ->getCollection()
                    		        ->addAttributeToFilter('entity_id', array('in' => $product_id))
                            		->addAttributeToSelect('*');

		$product = Mage::getModel('catalog/product')->load($product_id);
            
			foreach($productsCollection as $product) {
				try {
					$res[$id_counter]["quantity"] = $quantity;
					$quantity_sum+=$res[$id_counter]["quantity"];
					$res[$id_counter]["price"] = number_format($product->getPrice(),2);
					$price_sum+=($res[$id_counter]["price"]*$res[$id_counter]["quantity"]);
					$res[$id_counter]["Weight"] = number_format($product->getWeight(),2); 
					$weight_sum+=($res[$id_counter]["Weight"]*$res[$id_counter]["quantity"]);
				}
				catch(Exception $err) {
				}
			$id_counter= $id_counter+1;
			}  
		}       	
		//****** get all active carriers****************
		$methods = Mage::getSingleton('shipping/config')->getActiveCarriers();
		$shipping = array();
		foreach($methods as $_ccode => $_carrier) {
			if($_methods = $_carrier->getAllowedMethods()) {
				if(!$_title = Mage::getStoreConfig("carriers/$_ccode/title"))
					$_title = $_ccode;
					foreach($_methods as $_mcode => $_method) {
						$shippingcode = $_ccode . '_' . $_mcode;
						$ship_total=0;
						$shipping1=0;
								
						//*********CALCULATING THE FLAT RATE PRICE**********				
						if($_mcode=="flatrate"){
							
							$flat_flag_country=Mage::getStoreConfig('carriers/flatrate/sallowspecific');
							$flat_show_method=Mage::getStoreConfig('carriers/flatrate/showmethod');
							$flat_type=Mage::getStoreConfig('carriers/flatrate/type');
							$flat_item_price= Mage::getStoreConfig('carriers/flatrate/price');
							$flat_h_type=Mage::getStoreConfig('carriers/flatrate/handling_type');
							$flat_h_fee=Mage::getStoreConfig('carriers/flatrate/handling_fee');
							if($flat_h_fee=="" || $flat_item_price==""){
								$flat_h_fee=0;
								$flat_item_price=0;
								}
							if(empty($flat_type) && '0' != $flat_type){
								$ship_total=0;
							}
							elseif($flat_type=="I"){
								$ship_total=$flat_item_price*$quantity_sum;                           
							}
							else{
								$ship_total+=$flat_item_price;
							}
							if($flat_h_type=="F"){
								$ship_total+=$flat_h_fee;
							}
							else{
								$ship_total+=(($ship_total*$flat_h_fee)/100);
							}
							
							if($flat_flag_country==0){
								$shipping1=1;
							}
							else{
								$flat_specific_country=Mage::getStoreConfig('carriers/flatrate/specificcountry');
								$flat_specific_country = explode(",",$flat_specific_country);
								if(count($flat_specific_country)>0 && in_array($dest_country,$flat_specific_country)){
									$shipping1=1;
								}
								else{
									if($flat_show_method==1){
										$shipping1=1;
									}
									else{
										$shipping1=0;
									}
								}
							}			
								
						}
						//*******CALCULATING THE FREESHIPPING PRICE********					              
						if($_mcode=="freeshipping"){
						    $ship_total="";
						    $free_flag_country=Mage::getStoreConfig('carriers/freeshipping/sallowspecific');
							$free_show_method=Mage::getStoreConfig('carriers/freeshipping/showmethod');
							$free_min_order_price=Mage::getStoreConfig('carriers/freeshipping/free_shipping_subtotal');
							if($price_sum>=$free_min_order_price){
								$ship_total=0;
								
							}
							else{
								$ship_total="";
							}
							if (empty($ship_total) && '0' != $ship_total){
							 	$shipping1=0;
							}
							else {
							$shipping1=1;
								if($free_flag_country==0){
									$shipping1=1;
								}
								else{
									$free_specific_country=Mage::getStoreConfig('carriers/flatrate/specificcountry');
									$free_specific_country = explode(",",$free_specific_country);
									if(count($free_specific_country)>0 && in_array($dest_country,$free_specific_country)){
										$shipping1=1;
									}
									else{
										if($free_show_method==1){
											$shipping1=1;
										}
										else{
											$shipping1=0;
										}
									}
								}
							}					
							
						}
						//*******CALCULATING THE TABLE RATE PRICE*******	
						if($_mcode=="bestway"){
							$table_flag_country=Mage::getStoreConfig('carriers/tablerate/sallowspecific');
							$table_show_method=Mage::getStoreConfig('carriers/tablerate/showmethod');
							$table_h_fee=Mage::getStoreConfig('carriers/tablerate/handling_fee');
							$table_h_type=Mage::getStoreConfig('carriers/tablerate/handling_type');
							$table=array();
							$table_condition_name=Mage::getStoreConfig('carriers/tablerate/condition_name');
							$tablerateColl = Mage::getResourceModel('shipping/carrier_tablerate_collection');
							$table_counter=0;					
							foreach ($tablerateColl as $tablerate) {
   								$table_rate1[$table_counter]=$tablerate->debug();
   								$table_counter+=1;
							}
							if($table_h_fee==""){
							$table_h_fee=0;
							}
							
							//***FOR PACKAGE WEIGHT VS DESTINATION TABLE RATE****									
							if($table_condition_name=="package_weight"){
								$table_counter1=0;
								$table_counter11=0;
								$table_counter12=0;
								$table_new=array();
								foreach($table_rate1 as $table){
									if($table_rate1[$table_counter1]['dest_region']==""){
										$table_rate1[$table_counter1]['dest_region']="*";						
									}
									if(($table_rate1[$table_counter1]['dest_country']==$dest_country || $table_rate1[$table_counter1]['dest_region']==$dest_region) && $table_rate1[$table_counter1]['dest_zip']==$dest_zip && $table_rate1[$table_counter1]['condition_name']=="package_weight"){
										if($table_rate1[$table_counter1]['dest_country']==$dest_country && $table_rate1[$table_counter1]['dest_region']==$dest_region && $table_rate1[$table_counter1]['dest_zip']==$dest_zip){
											$table_new[$table_counter11]=$table_rate1[$table_counter1];
    										$table_counter11+=1;
										}
									}
									$table_counter1+=1;
								}
								if($table_counter11==1 && $weight_sum>=$table_new[0]['condition_value']){
									$ship_total=$table_new[0]['price'];
								}
								if($table_counter11>1){
									foreach($table_new as $count){
										if(($weight_sum>=$table_new[$table_counter12]['condition_value']) && ($weight_sum<$table_new[$table_counter12+1]['condition_value'])  ){
											$ship_total=$table_new[$table_counter12]['price'];
										}
										$table_counter12+=1;
									}
									if($weight_sum>=$table_new[$table_counter12-1]['condition_value']){
										$ship_total=$table_new[$table_counter12-1]['price'];
									}				
								}
							}																		
							//******FOR PRICE VS DESTINATION TABLE RATE******											
							if($table_condition_name=="package_value"){
								$table_counter2=0;
								$table_counter21=0;
								$table_counter22=0;
								$table_new=array();
								foreach($table_rate1 as $table){
									if($table_rate1[$table_counter2]['dest_region']==""){
										$table_rate1[$table_counter2]['dest_region']="*";						
									}
									if(($table_rate1[$table_counter2]['dest_country']==$dest_country || $table_rate1[$table_counter2]['dest_region']==$dest_region) && $table_rate1[$table_counter2]['dest_zip']==$dest_zip && $table_rate1[$table_counter2]['condition_name']=="package_value"){
										if($table_rate1[$table_counter2]['dest_country']==$dest_country && $table_rate1[$table_counter2]['dest_region']==$dest_region && $table_rate1[$table_counter2]['dest_zip']==$dest_zip){
											$table_new[$table_counter21]=$table_rate1[$table_counter2];
											$table_counter21+=1;
										}
									}
									$table_counter2+=1;
								}
								
								if($table_counter21==1 && $price_sum>=$table_new[0]['condition_value']){
									$ship_total=$table_new[0]['price'];
								}
								if($table_counter21>1){
									foreach($table_new as $count){
										if(($price_sum>=$table_new[$table_counter22]['condition_value']) && ($price_sum<$table_new[$table_counter22+1]['condition_value'])  ){
											$ship_total=$table_new[$table_counter22]['price'];
									}
										$table_counter22+=1;			
								}
									if($price_sum>=$table_new[$table_counter22-1]['condition_value']){
										$ship_total=$table_new[$table_counter22-1]['price'];
									}				
								}
							}																
							//*******FOR ITEMS VS DESTINATON TABLE RATE*********	
							if($table_condition_name=="package_qty"){
								$table_counter3=0;
								$table_counter31=0;
								$table_counter32=0;
								$table_new=array();
								foreach($table_rate1 as $table){
									if($table_rate1[$table_counter3]['dest_region']==""){
										$table_rate1[$table_counter3]['dest_region']="*";						
									}
									if(($table_rate1[$table_counter3]['dest_country']==$dest_country || $table_rate1[$table_counter3]['dest_region']==$dest_region) && $table_rate1[$table_counter3]['dest_zip']==$dest_zip && $table_rate1[$table_counter3]['condition_name']=="package_qty"){
										if( $table_rate1[$table_counter3]['dest_country']==$dest_country && $table_rate1[$table_counter3]['dest_region']==$dest_region && $table_rate1[$table_counter3]['dest_zip']==$dest_zip){
											$table_new[$table_counter31]=$table_rate1[$table_counter3];
											$table_counter31+=1;
										}
									}
									$table_counter3+=1;
								}
								if($table_counter31==1 && $quantity_sum>=$table_new[0]['condition_value']){
									$ship_total=$table_new[0]['price'];
								}
								if($table_counter31>1){
									foreach($table_new as $count){
										if(($quantity_sum>=$table_new[$table_counter32]['condition_value']) && ($quantity_sum<$table_new[$table_counter32+1]['condition_value'])){
											$ship_total=$table_new[$table_counter32]['price'];
										}
										$table_counter32+=1;			
									}
								if($quantity_sum>=$table_new[$table_counter32-1]['condition_value']){
									$ship_total=$table_new[$table_counter32-1]['price'];
								}	
							}
						}						
						if($ship_total=="" ){
						}
						else{
							$shipping1=1;
							if($table_h_type=="F"){
								$ship_total+=$table_h_fee;	
							}
							else{
								$ship_total+=(($ship_total*$table_h_fee)/100);
							}
							if($table_flag_country==0){
								$shipping1=1;
							}
							else{
								$table_specific_country=Mage::getStoreConfig('carriers/flatrate/specificcountry');
								$table_specific_country = explode(",",$table_specific_country);
								if(count($table_specific_country)>0 && in_array($dest_country,$table_specific_country)){
									$shipping1=1;
								}
								else{
									if($table_show_method==1){
										$shipping1=1;
									}
									else{
										$shipping1=0;
									}
								}
							}
						}						
							
					}
				$shipping[]=array('title' => $_title,'method' => $_method,'price'=>$ship_total,'shippingcode'=>$shippingcode ,'Status'=>$shipping1);
				}
			}
		}
			return($shipping);
	}
	/*====================  list all state list of specific country =================*/  	
	 public function ws_countryStateList($store_id,$country) {
		 $state = array();
		 if($country!="") {
			 try {
				 $_states = $us = Mage::getModel('directory/region_api')->items($country);
				  
				 if (count($_states) > 0) {
					foreach($_states as $_state) {
						if($_state['code']!="")
						$state[$_state['code']]  = $_state['name'];
					}
				  }
				  else {
					$state["result"] = "0"; 
				  } 
			}
			catch (Exception $exception) {
                  $state["result"] = "0"; 
             }
		}		
        return($state);
    }   
		   
}


