<?php
$installer = $this;  //Getting Installer Class Object In A Variable
$installer->startSetup();
$installer->run("
DROP TABLE IF EXISTS {$this->getTable('mofluidadmin/mofluidadmin')};
DROP TABLE IF EXISTS {$this->getTable('mofluidadmin/mofluidandroid')};
DROP TABLE IF EXISTS {$this->getTable('mofluidadmin/mofluidiphone')};
DROP TABLE IF EXISTS {$this->getTable('mofluidadmin/mofluidcommon')};
DROP TABLE IF EXISTS {$this->getTable('mofluidadmin/mofluidresource')};

CREATE TABLE IF NOT EXISTS {$this->getTable('mofluidadmin/mofluidresource')} (
  `resourceid` int(11) unsigned NOT NULL AUTO_INCREMENT, 
  `module` varchar(63) default '',
  `resource_name` varchar(63) default '',
  `resource` varchar(63) NOT NULL default '',
  `version` varchar(16) NOT NULL default '0',
  `sendbuildmode` int(16) NOT NULL default 0,
  PRIMARY KEY (`resourceid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS {$this->getTable('mofluidadmin/mofluidadmin')} (
  `mofluidadmin_id` int(11) unsigned NOT NULL,
  `mofluid_id` varchar(128) default '',
  `mofluid_key` varchar(63) NOT NULL default '',
  `androidcount` int(16) NOT NULL default '0',
  `iphonecount` int(16) NOT NULL default '0',
  `desc` varchar(255) default '',
  PRIMARY KEY (`mofluidadmin_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS {$this->getTable('mofluidadmin/mofluidandroid')} (
  `mofluidadmin_id` int(11) unsigned NOT NULL,
  `app_name` varchar(126) default '',
  `bundle_id` varchar(126) NOT NULL default '',
  `version` int(16) NOT NULL default '1',
  `default_store` int(16) NOT NULL default '1',
  `release_key` varchar(255) default '',
  `keystore_pswd` varchar(127) default '',
  `privatekey_pswd` varchar(127) default '',
  `key_status` int(16) NOT NULL default '0',
  `key_data` varchar(255) default '',
  `key_validity` int(16) NOT NULL default '10000',
  `currency_type` varchar(6) NOT NULL default 'USD',
  `cod_status` int(16) default '0',
  `paypal_status` int(16) default '0',
  `paypal_email` varchar(255) default '',
  `ebs_status` int(16) default '0',
  `ebs_id` varchar(125) default '',
  `ebs_key` varchar(125) default '',
  `ico_drawable` varchar(255) default '',
  `ico_hdpi` varchar(255) default '',
  `ico_ldpi` varchar(255) default '',
  `ico_mdpi` varchar(255) default '',  
  `ico_xhdpi` varchar(255) default '',
  `splash_drawable` varchar(255) default '',
  `splash_hdpi` varchar(255) default '',
  `splash_ldpi` varchar(255) default '',
  `splash_mdpi` varchar(255) default '',
  `splash_xhdpi` varchar(255) default '',
  `app_image_type` varchar(255) default 'dark',
  `app_img_home` varchar(255) default '',
  `app_img_back` varchar(255) default '',
  `app_img_cross` varchar(255) default '',
  `app_img_del` varchar(255) default '',
  `app_img_cart` varchar(255) default '',
  `app_img_menu` varchar(255) default '',
  `app_img_search` varchar(255) default '',
  `banner` varchar(255) default '',
  `logo` varchar(255) default '',
  `theme_background` varchar(125) default '',
  `theme_text` varchar(125) default '',
  `theme_header` varchar(125) default '',
  `theme_title` varchar(125) default '',
  `theme_button` varchar(125) default '',
  `valid_app` int(16) NOT NULL default '0',
  `valid_pay` int(16) NOT NULL default '0',
  `valid_assets` int(16) NOT NULL default '0',
  `valid_theme` int(16) NOT NULL default '0',
   PRIMARY KEY (`mofluidadmin_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS {$this->getTable('mofluidadmin/mofluidcommon')} (
  `id` int(16) NOT NULL default '1',
  `build_url` varchar(250) NOT NULL default '',
  `build_app_type` varchar(250) NOT NULL default '',
   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS {$this->getTable('mofluidadmin/mofluidiphone')} (
  `mofluidadmin_id` int(11) unsigned NOT NULL,
  `app_name` varchar(126) default '',
  `bundle_id` varchar(126) NOT NULL default '',
  `version` int(16) NOT NULL default '1',
  `default_store` int(16) NOT NULL default '1',
  `link_set` varchar(511) default '',
  `currency_type` varchar(6) NOT NULL default 'USD',
  `cod_status` int(16) default '0',
  `paypal_status` int(16) default '0',
  `paypal_email` varchar(255) default '',
  `ebs_status` int(16) default '0',
  `ebs_id` varchar(125) default '',
  `ebs_key` varchar(125) default '',
  `ico_drawable` varchar(255) default '',
  `ico_hdpi` varchar(255) default '',
  `ico_ldpi` varchar(255) default '',
  `ico_mdpi` varchar(255) default '',  
  `ico_xhdpi` varchar(255) default '',
  `splash_drawable` varchar(255) default '',
  `splash_hdpi` varchar(255) default '',
  `splash_ldpi` varchar(255) default '',
  `splash_mdpi` varchar(255) default '',
  `splash_xhdpi` varchar(255) default '',
  `app_image_type` varchar(255) default 'dark',
  `app_img_home` varchar(255) default '',
  `app_img_back` varchar(255) default '',
  `app_img_cross` varchar(255) default '',
  `app_img_del` varchar(255) default '',
  `app_img_cart` varchar(255) default '',
  `app_img_menu` varchar(255) default '',
  `app_img_search` varchar(255) default '',
  `banner` varchar(255) default '',
  `logo` varchar(255) default '',
  `theme_background` varchar(125) default '',
  `theme_text` varchar(125) default '',
  `theme_header` varchar(125) default '',
  `theme_title` varchar(125) default '',
  `theme_button` varchar(125) default '',  
  `valid_app` int(16) NOT NULL default '0',
  `valid_pay` int(16) NOT NULL default '0',
  `valid_assets` int(16) NOT NULL default '0',
  `valid_theme` int(16) NOT NULL default '0',
  `device_udid` varchar(500) default '',
    PRIMARY KEY (`mofluidadmin_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO {$this->getTable('mofluidadmin/mofluidresource')} (module, resource_name, resource, version, sendbuildmode) VALUES ('Mofluid_Mofluidadmin','mofluidadmin_setup','{$this->getTable('mofluidadmin/mofluidresource')}','1.10.0',0);
INSERT INTO {$this->getTable('mofluidadmin/mofluidresource')} (module, resource_name, resource, version, sendbuildmode) VALUES ('Mofluid_Mofluidadmin','mofluidadmin_setup','{$this->getTable('mofluidadmin/mofluidadmin')}','1.10.0',1);
INSERT INTO {$this->getTable('mofluidadmin/mofluidresource')} (module, resource_name, resource, version, sendbuildmode) VALUES ('Mofluid_Mofluidadmin','mofluidadmin_setup','{$this->getTable('mofluidadmin/mofluidandroid')}','1.10.0',1);
INSERT INTO {$this->getTable('mofluidadmin/mofluidresource')} (module, resource_name, resource, version, sendbuildmode) VALUES ('Mofluid_Mofluidadmin','mofluidadmin_setup','{$this->getTable('mofluidadmin/mofluidiphone')}','1.10.0',1);
INSERT INTO {$this->getTable('mofluidadmin/mofluidresource')} (module, resource_name, resource, version, sendbuildmode) VALUES ('Mofluid_Mofluidadmin','mofluidadmin_setup','{$this->getTable('mofluidadmin/mofluidcommon')}','1.10.0',1);


INSERT INTO {$this->getTable('mofluidadmin/mofluidcommon')} (id, build_url, build_app_type) VALUES(1,'http://125.63.92.59/Mofluid/Production1.10.0','Production');
INSERT INTO {$this->getTable('mofluidadmin/mofluidadmin')} (mofluidadmin_id, mofluid_id, mofluid_key, androidcount, iphonecount) VALUES(1,'','',0,0);
INSERT INTO {$this->getTable('mofluidadmin/mofluidandroid')} (mofluidadmin_id, app_name, bundle_id, version, default_store) VALUES(1,'','',1,1);
INSERT INTO {$this->getTable('mofluidadmin/mofluidiphone')} (mofluidadmin_id, app_name, bundle_id, version, default_store) VALUES(1,'','',1,1);



");
$installer->endSetup();
?>
